function $(a){return parent.document.getElementById(a)}
function getScrollXY()
{
	var scrOfX = 0, scrOfY = 0;
	if( typeof( window.pageYOffset ) == 'number' ) {
		//Netscape compliant
		scrOfY = window.pageYOffset; scrOfX = window.pageXOffset;
	} else if( document.body && ( document.body.scrollLeft || document.body.scrollTop ) ) {
		//DOM compliant
		scrOfY = document.body.scrollTop; scrOfX = document.body.scrollLeft;
	} else if( document.documentElement && ( document.documentElement.scrollLeft || document.documentElement.scrollTop ) ) {
		//IE6 standards compliant mode
		scrOfY = document.documentElement.scrollTop; scrOfX = document.documentElement.scrollLeft;
	}
	return [ scrOfX, scrOfY ];
}
function getScrollX()
{ return getScrollXY()[0]; }
function getScrollY()
{ return getScrollXY()[1]; }
function setXY(o,x,y)
{ o.style.left = x+'px'; o.style.top = y+'px'; }
function getScreenSize(w) {
	if ( typeof( w.innerHeight ) == 'number')
		return [w.innerWidth, w.innerHeight];
	else if (w.document.documentElement && (w.document.documentElement.clientHeight))
		return [w.document.documentElement.clientWidth, w.document.documentElement.clientHeight];
	else if (w.document.body && ( w.document.body.clientHeight))
		return [w.document.body.clientWidth, w.document.body.clientHeight];
	return 0;
}
function getXY(o)
{
	var xy = function (o, x, y) {
		if (o) return xy(o.offsetParent, x+o.offsetLeft, y+o.offsetTop);
		else return [x,y]; }
	return xy(o,0,0);
}
function addEvent(elm, ev, fn, useCapture)
{              
   useCapture = useCapture || false;
   if(elm.addEventListner){ elm.addEventListner('on'+ev,fn,useCapture); return true;
   }else if(elm.attachEvent){ var oTmp = elm.attachEvent('on'+ev,fn); return oTmp;
   }else{ elm['on'+ev] = fn; }      
}

var interval = 50;
var speed = 1;
var cellsize = 50;
var root = null;

function derive(c, b)
{
	var p;
	if (c == b) return;
	for (p in b.prototype)
		if (typeof(b.prototype[p]) == 'function' && !c.prototype[p]) c.prototype[p] = b.prototype[p];
	var n = b.toString();
	n = n.substring(n.indexOf(" ")+1, n.indexOf("("));
	c.prototype[n] = b;
}
function map(f,l)
{ 
	var v = [];
	for (i in l) v[i] = f(l[i]);
	return v;
}

var ROPAS = function() {
	return { util: {},
			image: {},
			effect: {},
			object: {}
			};
} ();

ROPAS.util.Object = function() {}

ROPAS.util.Object.prototype = {
	obj: null,
	iX: 0,
	iY: 0,
	iAlpha: 0,
	show: function() { if (this.obj) this.obj.style.display='inline'; },
	hide: function() { if (this.obj) this.obj.style.display='none'; },
	move: function(iToX, iToY, effect, iDuration, cbFn)
	{
		if (effect)
		{
			var o = new effect(this);
			o.setup(this.iX, this.iY, iToX, iToY, iDuration, cbFn);
			o.start();
		}
		else
		{
			this._move(iToX,iToY);
			if (cbFn) cbFn();
		}
	},
	_move: function(x,y)
	{
		if (this.obj) setXY(this.obj, x, y);
		this.iX = x; this.iY = y;
	},
	opacity: function(iFrom, iTo, effect, iDuration, cbFn)
	{
		if (effect)
		{
			var o = new effect(this);
			o.setup(iFrom, iTo, iDuration, cbFn);
			o.start();
		}
		else
		{
			this.setOpacity(iTo);
			if (cbFn)
				cbFn();
		}
	},
	setOpacity: function(v)
	{
		if (this.obj)
		{
			this.obj.style.filter = 'alpha(opacity='+v+')';
			this.obj.style.opacity = (v/100);
		}
	}
};

ROPAS.util.Box = function(root, cx, cy, color)
{
	this.root = root;
	this.cx = cx; this.cy = cy;
	this.color = color;
	this.load();
};

ROPAS.util.Box.prototype = {
	root: null,
	obj: null,
	iX: 0, iY: 0,
	cx: 0, cy: 0,
	color: 'black',
	iAlpha: 0,
	load: function()
	{
		var o = this.root.document.createElement('div');
		o.style.display='none';
		o.style.position = 'absolute';
		setXY(o,this.iX,this.iY);
		o.style.width = (this.cx)+'px';
		o.style.height = (this.cy)+'px';
		o.style.border = '1px solid '+this.color;
		this.obj = o;
		if (this.root)
			this.root.document.body.appendChild(o);
	},
	size: function(cx,cy)
	{
		this.obj.style.width = cx+'px';
		this.obj.style.height = cy+'px';
	}
};

derive(ROPAS.util.Box, ROPAS.util.Object);

ROPAS.util.Image = function(url)
{
	this.url = url;
	this.load();
};

ROPAS.util.Image.total_cnt = 0;
ROPAS.util.Image.loaded_cnt = 0;
ROPAS.util.Image.isLoaded = function() { if (ROPAS.util.Image.total_cnt == ROPAS.util.Image.loaded_cnt) return true; else return false; }

ROPAS.util.Image.prototype = {
	url: null,
	obj: null,
	iX: 0, iY: 0,
	iAlpha: 0,
	load: function()
	{
		var o = document.createElement('img');
		var t = this;
		addEvent(o, 'load', function() { t.onload() });
		o.src = this.url;
		o.style.display='none';
		setXY(o,this.iX,this.iY);
		o.style.position = 'absolute';
		this.obj = o;
		document.body.appendChild(o);
		ROPAS.util.Image.total_cnt++;
	},
	onload: function()
	{
		ROPAS.util.Image.loaded_cnt++;
	}
};

derive(ROPAS.util.Image, ROPAS.util.Object);

ROPAS.util.TextBox = function() { this.load(); }

ROPAS.util.TextBox.prototype = {
	obj: null,
	iX:0, iY:0,
	load: function()
	{
		var o = document.createElement('div');
		o.style.margin='20px';
		o.style.display='none';
		o.style.position = 'absolute';
		o.innerHTML = '';
		this.obj = o;
		document.body.appendChild(o);
	},
	set: function(x,y,cx,cy,html)
	{
		var o = this.obj;
		this._move(x,y);
		o.innerHTML = html;
		o.style.display='none';
	},
	remove: function()
	{
		var o = this.obj;
		o.innerHTML = '';
	}
};
derive(ROPAS.util.TextBox, ROPAS.util.Object);

ROPAS.effect._refresh = function(o)
{
	o.update(interval);
	if (!o.isFinished()) setTimeout(function() { ROPAS.effect._refresh(o); }, interval);
	else if (o.callback) o.callback();
}

ROPAS.effect.Effect = function() { }

ROPAS.effect.Effect.prototype = {
	obj: null,
	callback: null,
	iDuration: 0,
	iTime: 0,
	iFrom: 0,
	setup: function() { },
	update: function(i) { },
	start: function() { ROPAS.effect._refresh(this); },
	isFinished: function() { return this.iDuration<=this.iTime; }
};

ROPAS.effect.SimpleOpacity = function(o) { this.obj = o; }

ROPAS.effect.SimpleOpacity.prototype = {
	iFrom: 0,
	f: null,
	setup: function(iFrom, iTo, iDuration, cbFn)
	{
		this.iTime = 0;
		this.iFrom = iFrom;
		this.iDuration = iDuration;
		this.f = function(x) { return (x>=iDuration)?iTo:(x*(iTo-iFrom)/iDuration)+iFrom; }
		this.callback = cbFn;
	},
	update: function(i)
	{
		this.iFrom = this.f(this.iTime);
		this.iTime += i;
		this.obj.setOpacity(this.iFrom);
	}
	
};

derive(ROPAS.effect.SimpleOpacity, ROPAS.effect.Effect);

ROPAS.effect.SimpleMove = function(o) { this.obj = o; }

ROPAS.effect.SimpleMove.prototype = {
	iX: 0, iY: 0,
	fx: null, fy: null,
	setup: function(iFromX, iFromY, iToX, iToY, iDuration, cbFn)
	{
		this.iTime = 0;
		this.iX = iFromX; this.iY = iFromY;
		this.iDuration = iDuration;
		this.fx = function(x) { return (x>=iDuration)?iToX:(x*(iToX-iFromX)/iDuration)+iFromX; }
		this.fy = function(x) { return (x>=iDuration)?iToY:(x*(iToY-iFromY)/iDuration)+iFromY; }
		this.callback = cbFn;
	},
	update: function(i)
	{
		this.iX = this.fx(this.iTime); this.iY = this.fy(this.iTime);
		this.iTime += i;
		this.obj._move(this.iX, this.iY);
	}
};
derive(ROPAS.effect.SimpleMove, ROPAS.effect.Effect);

ROPAS.effect.IncreMove = function(fn) { this.obj = fn; }

ROPAS.effect.IncreMove.prototype = {
	iX: 0, iY: 0,
	fx: null, fy: null,
	setup: function(iFromX, iFromY, iToX, iToY, iDuration, cbFn)
	{
		this.iTime = 0;
		this.iX = iFromX; this.iY = iFromY;
		this.iDuration = iDuration;
		var aX = (iToX-iFromX)/(iDuration*iDuration);
		var aY = (iToY-iFromY)/(iDuration*iDuration);
		this.fx = function(x) { return (x>=iDuration)?iToX:aX*x*x+iFromX; }
		this.fy = function(x) { return (x>=iDuration)?iToY:aY*x*x+iFromY; }
		this.callback = cbFn;
	},
	update: function(i)
	{
		this.iX = this.fx(this.iTime);
		this.iY = this.fy(this.iTime);
		this.iTime += i;
		this.obj._move(this.iX, this.iY);
	}
};
derive(ROPAS.effect.IncreMove, ROPAS.effect.Effect);

ROPAS.object.Character = function(n,v) { this.name = n;this.imgs = map(function (x) { return new ROPAS.util.Image(x); }, v) }

ROPAS.object.Character.prototype = {
	name:null,
	imgs:[],
	moveX:[0,-cellsize,0,+cellsize], moveY:[cellsize,0,-cellsize,0],
	status:0,
	iOpacity:100,
	x:0, y:0,
	set:function(x,y) {
		this.x = x*cellsize+9; this.y = y*cellsize-10;
		this.imgs[0].move(this.x,this.y);
		this.imgs[0].show();
		this.onmove(this.x, this.y);
	},
	_move:function(i,cb) {
		this.imgs[i].move(this.x, this.y);
		this.x += this.moveX[i];
		this.y += this.moveY[i];

		this.imgs[i].show();
		if (this.status != i) this.imgs[this.status].hide();
		this.status = i;
		v = this;
		this.imgs[i].move(this.x,this.y,ROPAS.effect.SimpleMove,500*speed, cb);
		this.onmove(this.x, this.y);
	},
	onmove:function(x,y) { },
	left:function(v,cb) { if (!v) this._move(1,cb); else this._move(3,cb); },
	right:function(v,cb) { if (!v) this._move(3,cb); else this._move(1,cb); },
	down:function(v,cb) { if (!v) this._move(0,cb); else this._move(2,cb); },
	up:function(v,cb) { if (!v) this._move(2,cb); else this._move(0,cb); },
	stop:function() {
		this.imgs[0].move(this.x, this.y);
		this.imgs[0].show();
		if (this.status != 0) this.imgs[this.status].hide();
		this.status = 0;
	},
	_opacity:function(o) {
		if (o<0) o=0;
		if (o>100) o=100;
		this.iOpacity = o;
	},
	_reset:function(v) {
		for (i=0; i<this.imgs.length; i++)
			if (i != v) 
				this.imgs[i].setOpacity(this.iOpacity);
	},
	hide:function(d,cb) {
		var opa = 90;
		this.imgs[this.status].opacity(this.iOpacity, this.iOpacity-opa, ROPAS.effect.SimpleOpacity, d*speed, cb);
		this._opacity(this.iOpacity-opa);
		this._reset(this.status);
	},
	show:function(d,cb) {
		var opa = 90;
		this.imgs[this.status].opacity(this.iOpacity, this.iOpacity+opa, ROPAS.effect.SimpleOpacity, d*speed, cb);
		this._opacity(this.iOpacity+opa);
		this._reset(this.status);
	}
};

ROPAS.object.Text = function() { }

ROPAS.object.Text.remove = function(o, cbFn)
{
	o.remove();
	if (cbFn) cbFn();
}

ROPAS.object.Text.hide = function(o, cbFn)
{ o.opacity(100, 0, ROPAS.effect.SimpleOpacity, 250*speed, function () { ROPAS.object.Text.remove(o, cbFn); }); }

ROPAS.object.Text.show = function(x,y,cx,cy,html, cbFn)
{
	var txt = new ROPAS.util.TextBox();
	txt.set(x,-cy,cx,cy,html);
	txt.show();
	txt.move(x,y,ROPAS.effect.IncreMove,500*speed, function () { setTimeout(function () { ROPAS.object.Text.hide(txt, cbFn); }, 1000*speed); } );
}

ROPAS.object.Map = function(wnd)
{ this.window = wnd; }

ROPAS.object.Map.prototype = {
	window: null,
	cx: 0, cy: 0,
	data: [],
	map: [],
	minimap: null,
	setup: function(cx,cy, data, wndMinimap) {
		this.cx = cx; this.cy = cy;
		this.data = data;
		var minimap = new ROPAS.object.Minimap(this.window, wndMinimap, 200, 200);
		this.minimap = minimap;
		this.minimap.setup(cx*cellsize,cy*cellsize, data);
		self.onscroll = function(o) { };
		addEvent(self, 'scroll', function(o) { minimap.setScroll(getScrollX(), getScrollY()); });
		this.init();
	},
	init: function()
	{
		var i=0;
		for(y=0; y<this.cy; y++)
			for(x=0; x<this.cx; x++)
			{
				if (this.data[i] == 10)
				{
					this.map[i] = new ROPAS.util.Image("map/basic/2.png");
					this.minimap.create(i,x*cellsize,y*cellsize,'black');
				}
				else if (this.data[i] == 11)
				{
					this.map[i] = new ROPAS.util.Image("map/basic/3.png");
					this.minimap.create(i,x*cellsize,y*cellsize,'black');
				}
				else if (this.data[i] == 12)
				{
					this.map[i] = new ROPAS.util.Image("map/basic/4.png");
					this.minimap.create(i,x*cellsize,y*cellsize,'black');
				}
				else
				{
					var r = Math.floor(Math.random() * 25);
					if (r>4) r=0;
					this.map[i] = new ROPAS.util.Image("map/basic/1-"+r+".png");
					this.map[i].move(x*cellsize,y*cellsize);
					this.map[i].show();
				}
				this.map[i].move(x*cellsize,y*cellsize);
				this.map[i].show();
				i++;
			}
	}
};

ROPAS.object.Minimap = function(window, wnd, width, height) {
	this.window = window;
	this.wnd = wnd;
	this.width = width;
	this.height = height;
};

ROPAS.object.Minimap.prototype = {
	window: null,
	wnd: null,
	boxWnd: null,
	boxCharacters: [],
	width: 0, height: 0,
	rx: 0, ry: 0, x: 0, y: 0, cx: 0, cy: 0,
	data: [],
	init: function()
	{
		var dcx = this.window.clientWidth;
		var dcy = this.window.clientHeight;
		var o = this.wnd;
		v = getXY(o);
		this.rx = v[0]; this.ry = v[1];
		var ccx = (this.width/this.cx)*(dcx-17);
		var ccy = (this.height/this.cy)*(dcy-17);
		this.boxWnd.size(ccx, ccy);
		this.setScroll(0,0);
		for (i in this.boxCharacters)
			this.boxCharacters[i].move(this.boxCharacters[i].xx+this.rx, this.boxCharacters[i].yy+this.ry);
	},
	setup: function(cx,cy, data) {
		this.x = 0; this.y = 0;
		this.cx = cx; this.cy = cy;
		this.data = data;
		var o = this.wnd;
		o.innerHTML = '';
		this.boxWnd = new ROPAS.util.Box(parent,0, 0, 'black');
		this.init();
		this.boxWnd.show();
	},
	setScroll: function(x,y) {
		this.x = (this.width/this.cx)*x; this.y = (this.height/this.cy)*y;
		this.boxWnd.move(this.rx+this.x, this.ry+this.y);
	},
	create: function(n,x,y,c) {
		var cx = 32;
		var cy = 32;
		x = (this.width/this.cx)*x; y = (this.width/this.cx)*y;
		cx = (this.width/this.cx)*cx; cy = (this.width/this.cx)*cy;
		this.boxCharacters[n] = new ROPAS.util.Box(parent,cx,cy,c);
		this.boxCharacters[n].xx = x;
		this.boxCharacters[n].yy = y;
		this.boxCharacters[n].move(this.rx+x, this.ry+y);
		this.boxCharacters[n].show();
	},
	move: function(i,x,y) {
		var cx = cellsize;
		var cy = cellsize;
		x = (this.width/this.cx)*x; y = (this.width/this.cx)*y;
		this.boxCharacters[i].xx = x;
		this.boxCharacters[i].yy = y;
		this.boxCharacters[i].move(this.rx+x, this.ry+y);
	}
};

ROPAS.util.ActionQueue = function() {}

function update(o) {
	var ot = $('tpos'); var oc = $('cpos');
	if (ot) ot.innerHTML = o.tpos;
	if (oc) oc.innerHTML = o.cpos;
}

ROPAS.util.ActionQueue._run = function(o)
{
	if (o.lock) return;
	o.lock = true;
	if (o.tpos != o.cpos)
	{
		b = o.tpos < o.cpos;
		if (o.tpos > o.cpos) action = o.queue[o.cpos++];
		if (o.tpos < o.cpos) action = o.queue[--o.cpos];
		action(function(v) { o.lock=false;ROPAS.util.ActionQueue._run(o); }, b);
		update(o);
	}
	else o.lock = false;
}

ROPAS.util.ActionQueue.prototype = {
	queue: [],
	lock: false,
	cpos: 0,
	tpos: 0,
	run: function(v) {
		this.tpos += v;
		if (this.tpos < 0) this.tpos = 0;
		if (this.tpos > this.queue.length) this.tpos = this.queue.length;
		update(this);

		ROPAS.util.ActionQueue._run(this);
	},
	reset: function() { this.tpos = 0; update(this); ROPAS.util.ActionQueue._run(this); },
	runAll: function() { this.tpos = this.queue.length; update(this); ROPAS.util.ActionQueue._run(this); },
	add: function(v) { this.queue[this.queue.length] = v; },
	stop: function() { this.tpos = this.cpos; update(this); }
};

ROPAS.util.Game = function(wnd, wndMinimap) {
	this.wnd = wnd;
	this.wndMinimap = wndMinimap;
}

ROPAS.util.Game.prototype = {
	wnd:null,
	wndMinimap:null,
	data:[],
	map:null,
	characters:[],
	runQueue:null,
	refresh: function() {
		this.map.minimap.init();
	},
	init: function(cx, cy, data) {
		this.runQueue = new ROPAS.util.ActionQueue();
		this.map = new ROPAS.object.Map(this.wnd);
		this.map.setup(cx, cy, data, this.wndMinimap);
		var colors = ['white', 'blue', 'blue', 'blue', 'blue', 'red', 'red', 'red', 'red'];
		for (var v=0; v<9; v++)
		{
			this.characters[v] = new ROPAS.object.Character (v,["imgs/"+v+"_d.gif", "imgs/"+v+"_l.gif", "imgs/"+v+"_u.gif", "imgs/"+v+"_r.gif"]);
			var oMinimap = this.map.minimap;
			this.map.minimap.create(v,0,0,colors[v]);
			this.characters[v].onmove = function(x,y) { oMinimap.move(this.name,x,y); };
		}

		for (y=0; y<cy; y++)
			for (x=0; x<cx; x++)
				if (data[x+(cy*y)] < 10)
					if (data[x+(cy*y)] > 0)
						this.characters[data[x+(cx*y)]-1].set(x,y);
	},
	setSceanario: function(s) {
		/*
	[['c1', 'right'], ['c2', 'left'], ['map', 2, 2, 'wall', 'create']],
	[['c1', 'down'], ['c2', 'down'], ['map', 2, 3, 'pond', 'create']],
	[['c1', 'down'], ['c2', 'left'], ['map', 2, 4, 'trap', 'create']],
		*/
		var c0 = this.characters[0];
		var c1 = this.characters[1];
		var c2 = this.characters[2];
		var c3 = this.characters[3];
		var c4 = this.characters[4];
		var c5 = this.characters[5];
		var c6 = this.characters[6];
		var c7 = this.characters[7];
		var c8 = this.characters[8];
		for (turn in s)
		{
			var cmd = 'action = function(v,r) { ';
			for (i in s[turn])
			{
				if ((s[turn][i][1] == 'left') ||
				    (s[turn][i][1] == 'right') ||
				    (s[turn][i][1] == 'up') ||
				    (s[turn][i][1] == 'up') ||
				    (s[turn][i][1] == 'down'))
					cmd += (s[turn][i][0]+'.'+s[turn][i][1]+'(r);');
			}
			cmd += 'setTimeout(v, 500); }';
			eval(cmd);
			this.runQueue.add(action);
		}

	},
	start: function() {
		this.runQueue.runAll();
	},
	next: function() {
		this.runQueue.run(1);
	},
	prev: function() {
		this.runQueue.run(-1);
	},
	reset: function() {
		this.runQueue.reset();
	},
	stop: function() {
		this.runQueue.stop();
	}
};

